require "defines"
require "script.gui"
require "script.constructions"
--require "script.cargo-manifest"

script.on_init(function() On_Init() end)
script.on_configuration_changed(function() On_Init() end)
script.on_load(function() On_Load() end)

--global variables
--space_status - is Space unlocked? ("locked", "ship_repair", "mun",  "free")
--space_construction_queue {player}{celestial_body}{queue} - contains the queued Items for construction
--space_storage{player}{celestial_body}{} contains the logistics of the available Items
--gui_mode - the mode the gui is in {"none", "queue", "storage", "demand"}


function On_Init()
  for i, player in ipairs(game.players) do player.force.reset_recipes() end
  --for i, player in ipairs(game.players) do player.force.reset_technologies() end
  if not global.space_status then
    global.space_status = "locked" end
  if not global.space_construction_queue then
    global.space_construction_queue = {}
  end
  if not global.space_storage then
    global.space_storage = {}
  end
  if not global.gui_mode then
    global.gui_mode = {}
  end
-- if not global.space_construction_queue["player"] then
--		table.insert(global.space_construction_queue, "player")
--  end
  for i, player in ipairs(game.players) do
		if not global.space_construction_queue[player.force.name] then
			table.insert(global.space_construction_queue, player.force.name)
			global.space_construction_queue[player.force.name] = {}
      table.insert(global.space_construction_queue[player.force.name], "new_earth")
      global.space_construction_queue[player.force.name]["new_earth"] = {}
		end
		if not global.space_storage[player.force.name] then
			table.insert(global.space_storage, player.force.name)
			global.space_storage[player.force.name] = {}
      table.insert(global.space_storage[player.force.name], "new_earth")
      global.space_storage[player.force.name]["new_earth"] = {}
		end
    if not global.gui_mode[player.name] then
      global.gui_mode = {}
      global.gui_mode[player.name] = "none"
    end
  end
  if global.space_status == "locked" and game.players[1] and read_satellites_sent_from_gui(game.players[1].force) then
    global.space_status = "ship_repair"
    AddToConstructionQueue(game.players[1].force, "ship-repairs")
    for i, player in ipairs(game.players) do
      if player.connected then
        player.print({"msg-sat-launch2"})
        player.print({"msg-sat-launch3"})
        player.print({"msg-sat-launch4"})
        player.print({"msg-sat-launch5"})
        player.print({"msg-sat-launch6"})
        player.print({"msg-sat-launch7"})
        init_gui(player)
      end
    end
  end
end

function On_Load()
end

script.on_event(defines.events.on_rocket_launched, function(event)
  force_name = event.rocket.force.name
  if not global.space_status then
    On_Init()
  end
  --for _, player in ipairs(game.players) do
    --player.print("Rocket Detected, state: " .. global.space_status ..
    --             " Number Sattelites: " .. event.rocket.get_item_count("satellite"))
  --end
  if event.rocket.get_item_count("satellite") >= 1 and global.space_status == "locked" then
    global.space_status = "ship_repair"
    AddToConstructionQueue(event.rocket.force, "ship-repairs")
    for i, player in ipairs(event.rocket.force.players) do
      if player.connected then
        player.print({"msg-sat-launch1"})
        player.print({"msg-sat-launch2"})
        player.print({"msg-sat-launch3"})
        player.print({"msg-sat-launch4"})
        player.print({"msg-sat-launch5"})
        player.print({"msg-sat-launch6"})
        player.print({"msg-sat-launch7"})
        init_gui(player)
        --open_gui(player)
      end
    end
  end
  update_space_storage(event.rocket, "new_earth")
  HandleConstructions(event.rocket.force, "new_earth")
  for i, player in ipairs(event.rocket.force.players) do
    if player.connected then
      update_GUI(player)
    end
  end
end)

function messageForce(mes, force)
  for i, player in ipairs(force.players) do
    if player.connected then
      player.print(mes)
    end
  end
end



script.on_event(defines.events.on_gui_click, function(event)
	local player = game.players[event.element.player_index]
	local name = event.element.name
	if (name == "space-construction-button") then
		open_GUI(player)
	elseif (name == "queue-add-button") then
		open_add_GUI(player)
  elseif string.sub(name, 1, 10) == "build-add-" then
    AddToConstructionQueue(player.force, string.sub(name, 11))
    close_add_GUI(player)
    update_GUI(player)
  elseif name == "queue-remove-button" then
    ClearLastFromQueue(player.force)
    update_GUI(player)
  elseif name == "build-cancel" then
    close_add_GUI(player)
	end
end)

script.on_event(defines.events.on_player_created, function(event)
    if event.player_index > 1 and global.space_status and not(global.space_status == "locked") then
      init_GUI(game.players[event.player_index])
    end
end)

script.on_event(defines.events.on_forces_merging, function(event)
	global.forces_ion_cannon_table[event.source.name] = nil
	for i, player in ipairs(game.players) do
		init_GUI(player)
	end
end)


--script.onevent(defines.events.onbuiltentity, function(event)
--	local func = onbuiltentityHandler[event.createdentity.name]
--	if func ~= nil then func(event.createdentity, event) end
--end)

--script.onevent(defines.events.onrobotbuiltentity, function(event)
--	(event.createdentity) end
--end)

--Code by Zwobot
function read_satellites_sent_from_gui(force)
    --game.player.print("Reading #satellites from " .. force.name)
    for i, player in ipairs(game.players) do
        local rocket_score = player.gui.left.rocket_score
        if rocket_score then
          local rocket_count = rocket_score.rocket_count
          global.rockets_sent = tonumber(rocket_count.caption)
          if rocket_count ~= nil then
            return true
              --game.player.print("FoundGUI: " .. tostring_ex(rocket_count.caption))
          end
        end
    end
end
