function GetDemandCount(force, item)
  if global.space_storage[force.name]["new_earth"][item.name] then
    return item.amount - global.space_storage[force.name]["new_earth"][item.name]
  else
    return item.amount
  end
end

function GetStorageCount(force, item)
  if global.space_storage[force.name]["new_earth"][item.name] then
    return global.space_storage[force.name]["new_earth"][item.name]
  else
    return 0
  end
end

function CheckForFinishedConstruction(force)
  if not global.space_construction_queue[force.name]["new_earth"][1]then
    return false
  end
  for i, item in ipairs(global.space_construction_queue[force.name]["new_earth"][1].ingredients) do
    if GetDemandCount(force, item) > 0 then
      return false
    end
  end
  return true
end

function CheckForQuestCompletion(force)
  --force.players[1].print ("Quest Check, queue Item: " .. global.space_construction_queue[force.name]["new_earth"][1].name)
  if global.space_construction_queue[force.name]["new_earth"][1].name == "ship-repairs" and global.space_status == "ship_repair" then
    global.space_status = "mun"
    for i, player in ipairs(force.players) do
      if player.connected then
        player.print({"msg-ship-repairs1"})
        player.print({"msg-ship-repairs2"})
        player.print({"msg-ship-repairs3"})
    end
    end
    return true
  end
  return false
end

function FinishConstruction(force)
  if global.space_construction_queue[force.name]["new_earth"][1] then
    for i, player in ipairs(force.players) do
      player.print("Construction finished: " .. global.space_construction_queue[force.name]["new_earth"][1].name)
    end
    for i, item in ipairs(global.space_construction_queue[force.name]["new_earth"][1].ingredients) do
      global.space_storage[force.name]["new_earth"][item.name] = global.space_storage[force.name]["new_earth"][item.name] - item.amount
    end
    --todo: Store the result somewhere besides the Oribital item list, maybe
    if CheckForQuestCompletion(force) == false then
      if not global.space_storage[force.name]["new_earth"][global.space_construction_queue[force.name]["new_earth"][1].products[1].name] then
        global.space_storage[force.name]["new_earth"][global.space_construction_queue[force.name]["new_earth"][1].products[1].name] = 1
      else
        global.space_storage[force.name]["new_earth"][global.space_construction_queue[force.name]["new_earth"][1].products[1].name] = global.space_storage[force.name]["new_earth"][global.space_construction_queue[force.name]["new_earth"][1].products[1].name] + 1
      end
    end
    table.remove(global.space_construction_queue[force.name]["new_earth"], 1)
  end
end


function AddToConstructionQueue(force, ItemName)
  --force.players[1].print (ItemName)
  --force.players[1].print ("Add Recipe: " .. force.recipes[ItemName].name)
  table.insert(global.space_construction_queue[force.name]["new_earth"], force.recipes[ItemName])
  HandleConstructions(force, "new_earth")
end

function ClearLastFromQueue(force)
  --force.players[1].print("LastItem: " .. #global.space_construction_queue[force.name]["new_earth"])
  if #global.space_construction_queue[force.name]["new_earth"] > 0 then
    table.remove(global.space_construction_queue[force.name]["new_earth"], #global.space_construction_queue[force.name]["new_earth"])
  end
end

function update_space_storage(rocket, location)
	if rocket.get_item_count("cargo-pod-solar") > 0 then
    if not global.space_storage[rocket.force.name][location]["cargo-pod-solar"] then
      global.space_storage[rocket.force.name][location]["cargo-pod-solar"] = 1
    else
      global.space_storage[rocket.force.name][location]["cargo-pod-solar"] = global.space_storage[rocket.force.name]["new_earth"]["cargo-pod-solar"] + 1
    end
  elseif rocket.get_item_count("cargo-pod-structural") > 0 then
    if not global.space_storage[rocket.force.name][location]["cargo-pod-structural"] then
      global.space_storage[rocket.force.name][location]["cargo-pod-structural"] = 1
    else
      global.space_storage[rocket.force.name][location]["cargo-pod-structural"] = global.space_storage[rocket.force.name]["new_earth"]["cargo-pod-structural"]+ 1
    end
  elseif rocket.get_item_count("cargo-pod-energy") > 0 then
    if not global.space_storage[rocket.force.name][location]["cargo-pod-energy"] then
      global.space_storage[rocket.force.name][location]["cargo-pod-energy"] = 1
    else
      global.space_storage[rocket.force.name][location]["cargo-pod-energy"] = global.space_storage[rocket.force.name]["new_earth"]["cargo-pod-energy"] + 1
    end
  elseif rocket.get_item_count("cargo-pod-vacuum-thruster") > 0 then
    if not global.space_storage[rocket.force.name][location]["cargo-pod-vacuum-thruster"] then
      global.space_storage[rocket.force.name][location]["cargo-pod-vacuum-thruster"] = 1
    else
      global.space_storage[rocket.force.name][location]["cargo-pod-vacuum-thruster"] = global.space_storage[rocket.force.name]["new_earth"]["cargo-pod-vacuum-thruster"] + 1
    end
  end
end

function HandleConstructions(force, location)
  while CheckForFinishedConstruction(force) == true do
    FinishConstruction(force)
  end
end