local frame
local ButtonFrame


function init_gui(player)
  if not player.connected then
		return
	end
  frame = player.gui.top["space-construction"]
  if (frame) then
    frame.destroy()
  end
  if player.gui.top["space-construction-button"] then
    player.gui.top["space-construction-button"].destroy()
  end
  if (not player.gui.top["space-construction-button"]) then
		player.gui.top.add{type="button", name="space-construction-button", caption={"space-factorio"}}
	end
end

function open_GUI(player)
  ButtonFrame = player.gui.top["space-construction-add"]
  if (ButtonFrame) then
    ButtonFrame.destroy()
  end
  if not global.gui_mode then
    On_Init()
  end
  --if player.connected then
  --  player.print("Button click, state = " .. global.gui_mode[player.name])
  --end
  local frame = player.gui.top["space-construction"]
	if global.gui_mode[player.name] == "queue" then
    global.gui_mode[player.name] = "demmand"
    update_GUI(player)
  elseif global.gui_mode[player.name] == "demmand" then
    global.gui_mode[player.name] = "storage"
    update_GUI(player)
  elseif global.gui_mode[player.name] == "storage" then
    global.gui_mode[player.name] = "none"
    update_GUI(player)
  else
    global.gui_mode[player.name] = "queue"
    update_GUI(player)
  end
end

function update_GUI(player)
  frame = player.gui.top["space-construction"]
	if global.gui_mode[player.name] == "queue" then
    if (frame) then
      frame.destroy()
    end
    frame = player.gui.top.add{type="frame", name="space-construction", direction="vertical"}
    frame.add{type="label", caption={"space-construction-queue"}}
    frame.add{type="table", colspan=1, name="space-construction-queue-table"}
    for i, recipe in ipairs(global.space_construction_queue[player.force.name]["new_earth"]) do
      frame["space-construction-queue-table"].add{type = "label", caption = {recipe.name}}
    end
    if  not (global.space_status == "locked") and not (global.space_status == "ship_repair") then
      frame.add{type="button", name="queue-add-button", caption={"add-to-queue"}}
      frame.add{type="button", name="queue-remove-button", caption={"remove-from-queue"}}
    end
  elseif global.gui_mode[player.name] == "demmand" then
    if (frame) then
      frame.destroy()
    end
    frame = player.gui.top.add{type="frame", name="space-construction", direction="vertical"}
    frame.add{type="label", caption={"space-demmand-next-item"}}
    if global.space_construction_queue[player.force.name]["new_earth"][1] then
      frame.add{type="table", colspan=2, name="space-construction-demmand-table"}
      for i, item in ipairs(global.space_construction_queue[player.force.name]["new_earth"][1].ingredients) do
        if GetDemandCount(player.force, item) > 0 then
          frame["space-construction-demmand-table"].add{type = "label", caption = {item.name}}
          frame["space-construction-demmand-table"].add{type = "label", caption = {"amount", GetDemandCount(player.force, item)}}
        end
      end
    else
      frame.add{type="label", caption={"space-queue-empty"}}
    end
  elseif global.gui_mode[player.name] == "storage" then
    if (frame) then
      frame.destroy()
    end
    frame = player.gui.top.add{type="frame", name="space-construction", direction="vertical"}
    frame.add{type="label", caption={"space-storage"}}
    --player.print ("Items in storage" .. #global.space_storage[player.force.name]["new_earth"])
    frame.add{type="table", colspan=2, name="space-construction-supply-table"}
    for i, count in pairs(global.space_storage[player.force.name]["new_earth"]) do
      --player.print (i)
      if count > 0 then
        frame["space-construction-supply-table"].add{type = "label", caption = {i}}
        frame["space-construction-supply-table"].add{type = "label", caption = {"amount", count}}
      end
    end
  else
    if (frame) then
      frame.destroy()
    end
  end
end

function open_add_GUI(player)
  ButtonAddFrame = player.gui.top["space-construction-add"]
  if (ButtonAddFrame) then
    ButtonAddFrame.destroy()
  end
  ButtonAddFrame = player.gui.top.add{type="frame", name="space-construction-add", direction="vertical"}
  ButtonAddFrame.add{type="button", name="build-add-planetary-cargo-ship", caption={"planetary-cargo-ship"}}
  ButtonAddFrame.add{type="button", name="build-cancel", caption={"cancel"}}
end

function close_add_GUI(player)
  ButtonAddFrame = player.gui.top["space-construction-add"]
  if (ButtonAddFrame) then
    ButtonAddFrame.destroy()
  end
end
